Subject: RE: [Sip] a question about the tag in From or To header

From: "Wang, Jin-Gen" <[email-masked]>
Date: Mon, 27 Dec 2004 01:55:40 -0700

Thanks, Adam. You answered our question on the RFC 3261 compliance. Now what's the reason that a same UAC needs to use different From tags for different calls?

Thanks.

Jin-Gen Wang
Level3 Communications, Inc.

-----Original Message-----
From: Adam Roach [mailto:[email-masked]]
Sent: Friday, December 24, 2004 12:18 AM
To: Wang, Jin-Gen
Cc: Nataraju A B; Cullen Jennings; [email-masked]
Subject: Re: [Sip] a question about the tag in From or To header

Wang, Jin-Gen wrote:

>Thanks for your reply. The From tag, Call-ID, and To tag are used to identify a dialog. Since Call-ID is already unique across time and space, it seems that it is sufficient the tags in From and To headers only need to be unique across space. Like ABN mentioned, interpretation 1 leads to a simpler implementation. Our question is: does interpretation 1 violate RFC 3261?
>  
>

Yes, it does. The text Cullen pointed out *comes* *from* RFC 3261. It 
basically says that intrepretation 1 is wrong.

/a

>Thanks.
>
>Jin-Gen Wang
>Level3 Communications, Inc.
>
>-----Original Message-----
>From: Nataraju A B [mailto:[email-masked]]
>Sent: Thursday, December 23, 2004 9:34 PM
>To: 'Cullen Jennings'; Wang, Jin-Gen; [email-masked]
>Subject: RE: [Sip] a question about the tag in From or To header
>
>
>Comments inline...
>
>Best Regards,
>Nataraju A.B.
>Kodiak Networks Ind Pvt Ltd.,
>Phone : +91 80 2222 7960 Xtn 555
>
>-----Original Message-----
>From: [email-masked] [mailto:[email-masked]] On Behalf Of
>Cullen Jennings
>Sent: Wednesday, December 22, 2004 9:27 PM
>To: Wang, Jin-Gen; [email-masked]
>Subject: Re: [Sip] a question about the tag in From or To header
>
>
>It seems that 
> 
>   Similarly, two INVITEs for different calls will
>   have different From tags, and two responses for different calls will
>   have different To tags."
>
>is pretty clear that you need to do Interpretation 2. Is there some
>problem
>with this and reason why you want to do 1?
>
>[ABN] the option 1 would be preferred to have simplicity in identifying
>the user from the from-tag itself....(that is an implementation issue
>only)
>
>On 12/17/04 11:34 AM, "Wang, Jin-Gen" <[email-masked]> wrote:
>
>  
>
>>We have a debate on how to interpret the following paragraph (RFC
>>    
>>
>3261,
>  
>
>>section 19.3):
>>
>>===========
>>19.3 Tags
>>   ...
>>
>>   When a tag is generated by a UA for insertion into a request or
>>   response, it MUST be globally unique and cryptographically random
>>   with at least 32 bits of randomness.  A property of this selection
>>   requirement is that a UA will place a different tag into the From
>>   header of an INVITE than it would place into the To header of the
>>   response to the same INVITE.  This is needed in order for a UA to
>>   invite itself to a session, a common case for "hairpinning" of
>>    
>>
>calls
>  
>
>>   in PSTN gateways.  Similarly, two INVITEs for different calls will
>>   have different From tags, and two responses for different calls
>>    
>>
>will
>  
>
>>   have different To tags.
>>
>>   ...
>>===========
>>
>>Interpretation 1: A tag needs to be globally unique across space (aka
>>    
>>
>UAs) but
>  
>
>>not across time because Call-ID (section 8.1.1.4) is already unique
>>    
>>
>across
>  
>
>>space and time for calls. So a same UAC can use a same >From tag in
>>    
>>
>different
>  
>
>>calls it imitates. And a same UAS can use a same To tag to respond to
>>different calls. A same UA uses different tags in >From and To
>>    
>>
>headers.
>  
>
>>Different UAs use different tags.
>>
>>Interpretation 2: A tag needs to be different for each call. So a same
>>    
>>
>UAC has
>  
>
>>to use two different tags in From header when it initiates two
>>    
>>
>different
>  
>
>>calls. And a same UAS has to use different tags in To headers for
>>    
>>
>different
>  
>
>>calls. 
>>
>>We would like to hear from the list which way we should interpret the
>>    
>>
>above
>  
>
>>paragraph or what is the right interpretation if both interpretations
>>    
>>
>are not
>  
>
>>accurate.
>>
>>Thanks.
>>
>>
>>Jin-Gen Wang
>>Level3 Communications, Inc.
>>
>>
>>
>>_______________________________________________
>>Sip mailing list  https://www1.ietf.org/mailman/listinfo/sip
>>This list is for NEW development of the core SIP Protocol
>>Use [email-masked] for questions on current sip
>>Use [email-masked] for new developments on the application of sip
>>    
>>
>
>
>_______________________________________________
>Sip mailing list  https://www1.ietf.org/mailman/listinfo/sip
>This list is for NEW development of the core SIP Protocol
>Use [email-masked] for questions on current sip
>Use [email-masked] for new developments on the application of sip
>
>
>_______________________________________________
>Sip mailing list  https://www1.ietf.org/mailman/listinfo/sip
>This list is for NEW development of the core SIP Protocol
>Use [email-masked] for questions on current sip
>Use [email-masked] for new developments on the application of sip
>
>  
>

_______________________________________________
Sip mailing list  https://www1.ietf.org/mailman/listinfo/sip
This list is for NEW development of the core SIP Protocol
Use [email-masked] for questions on current sip
Use [email-masked] for new developments on the application of sip

---

From: Cullen Jennings <[email-masked]>
Date: Mon, 27 Dec 2004 12:13:24 -0700

Not sure I know the answer to why it says this, but the problem is, now that
it does say this, some implementation might be counting on this when they
receive things. For example, they might use it as index to a hash with an
assumption that collisions will be rare.

On 12/27/04 1:55 AM, "Wang, Jin-Gen" <[email-masked]> wrote:

> Thanks, Adam. You answered our question on the RFC 3261 compliance. Now what's
> the reason that a same UAC needs to use different From tags for different
> calls?
> 
> Thanks.
> 
> Jin-Gen Wang
>> Thanks for your reply. The From tag, Call-ID, and To tag are used to identify
>> a dialog. Since Call-ID is already unique across time and space, it seems
>> that it is sufficient the tags in From and To headers only need to be unique
>> across space. Like ABN mentioned, interpretation 1 leads to a simpler
>> implementation. Our question is: does interpretation 1 violate RFC 3261?
>>  
>> 
>